# -*- coding: utf-8 -*-
# baroslized at 2007-08-01 13:26:34

__module_name__ = '빵글이'
__module_description__ = '빵글이 스크립트'
__module_version__ = '0.8'

import xchat
import os

id = ''
passwd = ''

def load_cfg():
	global id, passwd
	try: id, passwd = open('../config/data/ppanggeuri.txt').read().decode('cp949').encode('utf-8').split(' ')[:2]
	except: pass

def save_cfg():
	try: os.mkdir('../config/data')
	except: pass
	open('../config/data/ppanggeuri.txt', 'w').write((id+' '+passwd+'\n').decode('utf-8').encode('cp949'))

def login():
	xchat.command('quote PRIVMSG ^^ :인증 %s %s' % (id, passwd))
	xchat.command('quote MODE %s +x' % xchat.get_info('nick'))

def hook_welcomed(word, word_eol, userdata):
	if id: login()

def cmd_ppanggeuri(word, word_eol, userdata):
	if len(word) <= 2:
		print '빵글이 아이디와 비밀번호를 입력하세요.'
		return xchat.EAT_XCHAT

	global id, passwd
	id, passwd = word[1], word[2]
	save_cfg()
	print '빵글이 아이디와 비밀번호를 저장하였습니다.'
	login()
	return xchat.EAT_XCHAT

def cmd_ppanggeuri_join(word, word_eol, userdata):
	os.startfile('http://service.hanirc.org/')
	return xchat.EAT_XCHAT


xchat.hook_server('001', hook_welcomed)

help_str = '/로그인 "HanIRC 인증 시스템에 로그인합니다."'
xchat.hook_command('빵글이', cmd_ppanggeuri, help=help_str)
xchat.hook_command('로그인', cmd_ppanggeuri, help=help_str)

help_str = '/가입 "HanIRC 인증 시스템에 가입합니다."'
xchat.hook_command('가입', cmd_ppanggeuri_join, help=help_str)
xchat.hook_command('회원가입', cmd_ppanggeuri_join, help=help_str)

load_cfg()

# EndOfFile
