# -*- coding: utf-8 -*-
# baroslized at 2007-07-28 06:16:18

__module_name__ = 'update'
__module_description__ = 'InklChat Update'
__module_version__ = '0.4'

import xchat
import sys
import urllib2
import thread
import time
import zipfile
import shutil
import os

def update():
	time.sleep(0.5)

	if os.path.isdir('../system.new'): return

	current_version = sys.modules['b3d2cf3d7285e84839a9b9397ddc6dd8'].__module_version__.strip()
	try: latest_version = urllib2.urlopen('http://barosl.com/inklchat/files/ver.php').read().strip()
	except: return
	if current_version == latest_version: return

	print 'InklChat 새 버전이 나왔습니다.'
	print 'InklChat 업데이트를 수행합니다: %s -> %s' % (current_version, latest_version)

	fname = 'InklChat-%s.exe' % latest_version
	fp_from = urllib2.urlopen('http://barosl.com/inklchat/files/%s' % fname)
	fp_to = open(fname, 'wb')
	while True:
		buf = fp_from.read(1024*10)
		if not buf: break
		fp_to.write(buf)
	fp_from.close()
	fp_to.close()

	try: shutil.rmtree('../system.new')
	except: pass

	zf = zipfile.ZipFile(fname)
	for line in zf.namelist():
		if line.endswith('/') or line.endswith('\\'): continue
		if line.startswith('/'): line = line[1:]
		if not line.startswith('system/'): continue
		fpath = '../system.new/'+line[len('system/'):]
		try: os.makedirs(os.path.dirname(fpath))
		except: pass
		open(fpath, 'wb').write(zf.read(line))
	zf.close()

	os.remove(fname)

	print 'InklChat 업데이트를 완료하였습니다. 3초 후 InklChat을 재시작합니다.'
	time.sleep(3)
	xchat.command('exit')
	time.sleep(0.1)
	os.chdir('..')
	os.execv('inklchat', [])

def hook_welcomed(word, word_eol, userdata):
	thread.start_new_thread(update, ())

xchat.hook_server('001', hook_welcomed)

xchat.hook_command('업데이트', hook_welcomed, help='/업데이트 "인클챗 업데이트를 확인합니다."')

# EndOfFile
